Bug 43320 - Thread aborts in the middle of .cctor and hell break loose
Summary: Thread aborts in the middle of .cctor and hell break loose
Status: RESOLVED FIXED
Alias: None
Product: Runtime
Classification: Mono
Component: General (show other bugs)
Version: master
Hardware: PC Mac OS
: Normal normal
Target Milestone: Future Cycle (TBD)
Assignee: Rodrigo Kumpera
URL:
Depends on:
Blocks:
 
Reported: 2016-08-12 18:24 UTC by Rodrigo Kumpera
Modified: 2017-08-08 17:30 UTC (History)
4 users (show)

Tags:
Is this bug a regression?: ---
Last known good build:


Attachments

Description Rodrigo Kumpera 2016-08-12 18:24:24 UTC
This bug is tracking the discussion from https://github.com/mono/mono/pull/3369

The summary is that a TAE landing in a .cctor should be routed around and keep the type viable.

Right now the TAE lands straight in the middle of the .cctor, punch it in the face, ruins the type and sneaks out hidden in a TLE.
Comment 1 Andi McClure 2016-08-12 18:26:55 UTC
It seems like this is a regression.
Comment 2 Rodrigo Kumpera 2016-08-12 18:31:22 UTC
It's not a regression per-se. The wrong behavior always existed, but became much more problematic with Zoltan's change to switch thread stop to abort instead.

We discussed back then that we'd need to get this and Kyte's fix[1] in.



[1] https://github.com/mono/mono/pull/1837
Comment 3 Rodrigo Kumpera 2016-09-01 21:50:10 UTC
Merged, let's hope it works.
Comment 5 Rodrigo Kumpera 2017-08-08 17:30:38 UTC
We did another round of fixing around the cctor abort January 2017: https://github.com/mono/mono/pull/4274


CC'ing Vlad as he recently did some work on interruption - changed how finally guarding is done.

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.


Create a new report for Bug 43320 on Developer Community or GitHub if you have new information to add and do not yet see a matching report.

  • Export the original title and description: Developer Community HTML or GitHub Markdown
  • Copy the title and description into the new report. Adjust them to be up-to-date if needed.
  • Add your new information.

In special cases on GitHub you might also want the comments: GitHub Markdown with public comments


Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.

Related Links: